# frozen_string_literal: true

module Hermes
  # Picture serializer
  class PictureSerializer < ActiveModel::Serializer
    cache key: proc { "#{object.cache_key}" }, expires_in: 1.day
    attributes [
      :thumb240,
      :thumb1000,
      :full_size,
      :housing_offer_id
    ]
    type 'pictures'

    def thumb240
     (object.thumb240_id) && "#{Asset.public_relative_url(object.thumb240_id.to_s)}"
    end

    def thumb1000
      (object.thumb1000_id) && "#{Asset.public_relative_url(object.thumb1000_id.to_s)}"
    end

    def full_size
      (object.full_size_id) && "#{Asset.public_relative_url(object.full_size_id.to_s)}"
    end

    def housing_offer_id
      object.housing_offer&.id.to_s
    end
  end
end