#methode permettant de recuperer tout les logs dune housing request et de les donner a voir sous une forme lisible facilement
def get_logs(hr_id = nil)
  log_array = []
  logs = Hermes::Log.where(housing_request_id: hr_id||self.id).order_by(created_at: :desc)
  logs.each do |log|
    log_array.push( {
                      date: log.created_at,
                      action: log.action,
                      user_id: log.current_user_id.to_s
                    })
    return log_array
  end
end

# cette methode permet de checker quelle est la demande qui a ete vue suivant lheure de connexion
def security_check_request_viewed_by_other_script(created_at_value = nil, mail)
  applicant = Hermes::Applicant.find_by(email: mail)
  hr = Hermes::HousingRequest.where(:created_at.lt  => created_at_value || self.created_at, entity_id: applicant&.entity_id).order_by(created_at: :desc).first
  res = {
    viewed_housing_request_id: hr._id.to_s,
    viewed_created_at: hr.created_at,
    viewed_updated_at: hr.updated_at,
    viewed_entity_id: hr&.entity&.id&.to_s,
    viewed_mail: hr.main_applicant&.email,
    viewed_first_name: hr.main_applicant&.first_name,
    viewed_last_name: hr.main_applicant&.last_name,
    requester_applicant_id: applicant&.id&.to_s,
    requester_applicant_user_id: applicant&.user_id&.to_s,
    requester_applicant_entity_id: applicant&.entity_id&.to_s,
    
  }
  return res
end

#methode permettant de verifier si la demande a ete éditee par quelqu'un qui n'a pas (ou plus) les droits sur l'objet
def check_security_anomaly(hr_id = nil)
  hr = hr_id ?  Hermes::HousingRequest.find(hr_id):self
  log_array = hr.get_logs(hr_id || self.id)
  security_violations = []
  log_array.each do |log|
    if !hr.writable_by?(User.find(log.current_user_id))
      security_violation.push(log)
    end
  end
  return security_violations
end

def security_script_from_csv_to_csv(csv_input_path, csv_output_path, with_seecurity_anomaly_check = true)
  require 'csv'
  input_data = CSV.read(csv_input_path)
  output_data = []
  input_data.each_with_index do |input_line, i|
    if i>0
      requester_email =input_line[0].split(';')[0]
      requester_at = input_line[0].split(';')[1]
      res = security_check_request_viewed_by_other_script(requester_at,requester_email )
      res[:requester_email] = requester_email
      res[:requester_at] = requester_at
      if with_seecurity_anomaly_check
        secu_violations = check_security_anomaly(res[:viewed_housing_request_id])
        res[:security_potential_violation_nb] = secu_violations.length
        res[:security_potential_violation_detail] = secu_violations.to_json
      end
      output_data.push(res)
    end
  end
  CSV.open(csv_output_path, "wb") do |csv|
    csv << output_data.first.keys # adds the attributes name on the first line
    output_data.each do |hash|
      csv << hash.values
    end
  end
end

#Pour avoir la liste des demandes vues par les utilisateurs:
                                                
security_script_from_csv_to_csv('/home/webapp/historique_connexion_2207_2307_echantillon.csv', '/home/webapp/output_housing.csv', false)


#Pour avoir la liste des demandes modifiées alors qu'elles nauraient pas du l etre car le demandeur navait pas les droits :

security_script_from_csv_to_csv('/home/webapp/historique_connexion_2207_2307_echantillon.csv', '/home/webapp/output_housing_log.csv', true)