require 'rails_helper'

RSpec.describe Hermes::Disability, type: :model do
  it 'has a valid factory' do
    expect(FactoryBot.build(:disability)).to be_valid
  end

  describe 'validate title presence' do
    it 'is invalid without a name' do
      expect(FactoryBot.build(:disability, name: nil)).not_to be_valid
    end
  end

  describe 'validate referent save' do
    let!(:basic_disability) { create(:disability) }

    it 'put referent' do
      Hermes::DisabilityReferent.create(name: 'test', disability: basic_disability)
      expect(basic_disability.reload.disability_referent.name).to eq("test")
    end
  end
end
